"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getProjectStyleFile = exports.getDependencies = void 0;
const core_1 = require("@angular-devkit/core");
let NGX_BOOTSTRAP_VERSION = '7.0.0-rc.1';
const BOOTSTRAP_VERSION = '^4.5.0';
const dependencies = [
    { name: 'bootstrap', version: BOOTSTRAP_VERSION },
    { name: 'ngx-bootstrap', version: NGX_BOOTSTRAP_VERSION }
];
// Regular expression that matches all possible Angular CLI default style files
const defaultStyleFileRegex = /styles\.(c|le|sc|sa)ss/;
// Regular expression that matches all files that have a proper stylesheet extension
const validStyleFileRegex = /\.(c|le|sc|sa)ss/;
function getDependencies(host) {
    var _a;
    if (host.exists('node_modules/ngx-bootstrap/schematics/package.json')) {
        const sourceText = (_a = host.read('node_modules/ngx-bootstrap/schematics/package.json')) === null || _a === void 0 ? void 0 : _a.toString('utf-8');
        const json = JSON.parse(sourceText);
        if (json.version) {
            NGX_BOOTSTRAP_VERSION = json.version;
            return updateVersionDependencies(json.version, 'ngx-bootstrap');
        }
    }
    return dependencies;
}
exports.getDependencies = getDependencies;
function updateVersionDependencies(version, name) {
    dependencies.find(dep => {
        if (dep.name === name) {
            dep.version = version;
        }
    });
    return dependencies;
}
function getProjectStyleFile(existingStyles, extension) {
    const defaultExtension = existingStyles.find((file) => extension ? file === `styles.${extension}` : defaultStyleFileRegex.test(file));
    if (defaultExtension) {
        return defaultExtension;
    }
    ;
    const fallbackStylePath = existingStyles.find((file) => extension ? file === null || file === void 0 ? void 0 : file.endsWith(`.${extension}`) : validStyleFileRegex.test(file));
    if (fallbackStylePath) {
        return core_1.normalize(fallbackStylePath);
    }
    ;
}
exports.getProjectStyleFile = getProjectStyleFile;
//# sourceMappingURL=getVersions.js.map